/**
 * generated by Xtext
 */
package org.eclipse.etrice.core.fsm.fSM;

import org.eclipse.etrice.core.common.base.Documentation;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Choice Point</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * <br>A choice point corresponds to an {@code if else} construct.
 * It is the target of one or more {@link Transition}s and the
 * source of several {@link Transition}s.
 * One outgoing transitions must be a {@link ContinuationTransition}
 * and corresponds to the final else. It is called the
 * <em>default branch</em> of the choice point.
 * All other outgoing transitions have to be {@link CPBranchTransition}s.
 * 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.etrice.core.fsm.fSM.ChoicePoint#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.etrice.core.fsm.fSM.ChoicePoint#getDocu <em>Docu</em>}</li>
 * </ul>
 *
 * @see org.eclipse.etrice.core.fsm.fSM.FSMPackage#getChoicePoint()
 * @model
 * @generated
 */
public interface ChoicePoint extends StateGraphNode
{
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * <br>By this name the choice point is referred to in the model.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.etrice.core.fsm.fSM.FSMPackage#getChoicePoint_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.etrice.core.fsm.fSM.ChoicePoint#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Docu</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * <br>This is an optional documentation.
	 * 
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Docu</em>' containment reference.
	 * @see #setDocu(Documentation)
	 * @see org.eclipse.etrice.core.fsm.fSM.FSMPackage#getChoicePoint_Docu()
	 * @model containment="true"
	 * @generated
	 */
	Documentation getDocu();

	/**
	 * Sets the value of the '{@link org.eclipse.etrice.core.fsm.fSM.ChoicePoint#getDocu <em>Docu</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Docu</em>' containment reference.
	 * @see #getDocu()
	 * @generated
	 */
	void setDocu(Documentation value);

} // ChoicePoint
